//-----------------------------------------
// LScript Modeler template
//

@version 2.2
@warnings
@script modeler
@name Subpatch Cylinder
// global values go here
myversion=1.2;
//v1.1
// Added Subpatch toggle and fixed bug
//v1.2 
// Still wasn't working quite right, so I've make the Subpatch part non-interactive.

c0,c0a,c0b,c0c,c1,c2,c3,c4;
mydone=0;
mycentre=<0,0,0>;
mylength=1.0;
myradius=0.5;
mysegments=1;
//mynewpolys=nil;
mysub=1;
myaddpolys=nil;

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
main                                                            // THIS IS JUST THE REQUESTER
{   

    mycentre=recall("MGSubpatchCylmycentre",<0,0,0>);
    mylength=recall("MGSubpatchCylmylength",1.0);
    myradius=recall("MGSubpatchCylmyradius",0.5);
    mysegments=recall("MGSubpatchCylmysegments",1);
    mysub=recall("MGSubpatchCylmysub",1);
    selmode(USER);
    selpolygon(CLEAR);
    
    reqbegin("Subpatch Cylinder by Mike Green Version:"+myversion);
    reqsize(330,230);
    c0a = ctlpercent("Centre X",mycentre.x);
    c0b = ctlpercent("Y",mycentre.y);
    c0c = ctlpercent("Z",mycentre.z);

    c1 = ctlpercent("Length",mylength);
    c2 = ctlpercent("Radius",myradius);
    c3 = ctlminislider("Segments",mysegments,1,1000);
    c4 = ctlcheckbox("Subpatch",mysub);
    c5 = ctltext("Contact:","Dodgy@shortbutpurple.fsnet.co.uk");

    docylinder(0);                                  //calls docylinder for the first time. 

    ctlrefresh(c0a,"docylinder");                   //calls docylinder each time a parameter changes
    ctlrefresh(c0b,"docylinder");
    ctlrefresh(c0c,"docylinder");
    ctlrefresh(c1,"docylinder");
    ctlrefresh(c2,"docylinder");
    ctlrefresh(c3,"docylinder");
    ctlrefresh(c4,"docylinder");

    if (!reqpost())
    {
        undo();
        return;
    }

    reqend();

//===============================================================================================================
//===============================================================================================================

// THIS DOES THE SELECTION!!!

//debug();
    selmode(USER);
    selpolygon(CLEAR);                          //Clears any user selection


    if(mysub==1)
    {

// Selecting all the polys by ids from mynewpolys:

        selpolygon(SET,POLYID,myaddpolys);

        togglepatches();
    }
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



    store("MGSubpatchCylmycentre",mycentre);
    store("MGSubpatchCylmylength",mylength);
    store("MGSubpatchCylmyradius",myradius);
    store("MGSubpatchCylmysegments",mysegments);
    store("MGSubpatchCylmysub",mysub);  
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

docylinder:value
{
//debug();
//===============================================================================================================
//===============================================================================================================

// THIS DOES THE UNDOS!!!

    selmode(USER);
    if(mydone==1)
    {
        undo();
//        if(mysub==1)
//        {
//            undo();               // REMMING THIS OUT (ON ITS OWN) MAKES IT WORK, BUT LEAVES A TRAIL OF GEOMETRY
//        }

    }

//===============================================================================================================
//===============================================================================================================

// THIS GET THE PARAMETERS!!!

    mycentx=getvalue(c0a);
    mycenty=getvalue(c0b);
    mycentz=getvalue(c0c);
    mylength=getvalue(c1);
    myradius=getvalue(c2);
    mysegments=getvalue(c3);
    mysub=getvalue(c4);
    mysegments=max(1,mysegments);    

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// THIS BUILDS THE GEOMETERY!!!


    mycentre=<mycentx,mycenty,mycentz>;
    myseglen=mylength/mysegments;
    myoffset=mycentre.y-(mylength/2.0);
    myadj=sqrt((myradius^^2)/2);
    mypoints[1][1]=<0,0,0>;                 // this will be the array of pointids for building the geometry

//    mynewpolys=nil;                         // clear mynewpolys just  in case
    mynewpolys[1]=0;                        //mynewpolys is the array for the new polyids.
    editbegin();
        for(i=0;i<=mysegments;i++)
        {
            myy=((i*myseglen)+myoffset);
            mypoints[i+1][1]=addpoint(<mycentre.x           , myy , mycentre.z+myradius>);
            mypoints[i+1][2]=addpoint(<mycentre.x+myadj     , myy , mycentre.z+myadj>);
            mypoints[i+1][3]=addpoint(<mycentre.x+myradius  , myy , mycentre.z>);
            mypoints[i+1][4]=addpoint(<mycentre.x+myadj     , myy , mycentre.z-myadj>);
            mypoints[i+1][5]=addpoint(<mycentre.x           , myy , mycentre.z-myradius>);
            mypoints[i+1][6]=addpoint(<mycentre.x-myadj     , myy , mycentre.z-myadj>);
            mypoints[i+1][7]=addpoint(<mycentre.x-myradius  , myy , mycentre.z>);
            mypoints[i+1][8]=addpoint(<(mycentre.x-myadj)   , myy , mycentre.z+myadj>);
            if(i>0)
            {
                mypolys[1]=@1,1,1,1@;           // this will be the array of points to build each layer of polys.

                mypolys[1]=@mypoints[i][1],mypoints[i][2],mypoints[i+1][2],mypoints[i+1][1]@; //array of points for poly 1 of layer i
                mypolys[2]=@mypoints[i][2],mypoints[i][3],mypoints[i+1][3],mypoints[i+1][2]@; //array of points for poly 2 of layer i
                mypolys[3]=@mypoints[i][3],mypoints[i][4],mypoints[i+1][4],mypoints[i+1][3]@; //etc
                mypolys[4]=@mypoints[i][4],mypoints[i][5],mypoints[i+1][5],mypoints[i+1][4]@;
                mypolys[5]=@mypoints[i][5],mypoints[i][6],mypoints[i+1][6],mypoints[i+1][5]@;
                mypolys[6]=@mypoints[i][6],mypoints[i][7],mypoints[i+1][7],mypoints[i+1][6]@;
                mypolys[7]=@mypoints[i][7],mypoints[i][8],mypoints[i+1][8],mypoints[i+1][7]@;
                mypolys[8]=@mypoints[i][8],mypoints[i][1],mypoints[i+1][1],mypoints[i+1][8]@;

                mynewpolys[1+(i - 1)*8]=addpolygon(mypolys[1]);
                mynewpolys[2+(i - 1)*8]=addpolygon(mypolys[2]);
                mynewpolys[3+(i - 1)*8]=addpolygon(mypolys[3]);
                mynewpolys[4+(i - 1)*8]=addpolygon(mypolys[4]);
                mynewpolys[5+(i - 1)*8]=addpolygon(mypolys[5]);
                mynewpolys[6+(i - 1)*8]=addpolygon(mypolys[6]);
                mynewpolys[7+(i - 1)*8]=addpolygon(mypolys[7]);
                mynewpolys[8+(i - 1)*8]=addpolygon(mypolys[8]);
            }    
        }

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// THIS DOES THE END CAPS OF THE CYLINDER

        endpoint[1]=addpoint(<mycentre.x,myoffset,mycentre.z>);
        endpoint[2]=addpoint(<mycentre.x,myoffset+mylength,mycentre.z>);

        mypolys[1]=@endpoint[1],mypoints[1][3],mypoints[1][2],mypoints[1][1]@;
        mypolys[2]=@endpoint[1],mypoints[1][5],mypoints[1][4],mypoints[1][3]@;
        mypolys[3]=@endpoint[1],mypoints[1][7],mypoints[1][6],mypoints[1][5]@;
        mypolys[4]=@endpoint[1],mypoints[1][1],mypoints[1][8],mypoints[1][7]@;
        mypolys[5]=@endpoint[2],mypoints[mysegments+1][1],mypoints[mysegments+1][2],mypoints[mysegments+1][3]@;
        mypolys[6]=@endpoint[2],mypoints[mysegments+1][3],mypoints[mysegments+1][4],mypoints[mysegments+1][5]@;
        mypolys[7]=@endpoint[2],mypoints[mysegments+1][5],mypoints[mysegments+1][6],mypoints[mysegments+1][7]@;
        mypolys[8]=@endpoint[2],mypoints[mysegments+1][7],mypoints[mysegments+1][8],mypoints[mysegments+1][1]@;

        mynewpolys[1+(mysegments)*8]=addpolygon(mypolys[1]);
        mynewpolys[2+(mysegments)*8]=addpolygon(mypolys[2]);
        mynewpolys[3+(mysegments)*8]=addpolygon(mypolys[3]);
        mynewpolys[4+(mysegments)*8]=addpolygon(mypolys[4]);
        mynewpolys[5+(mysegments)*8]=addpolygon(mypolys[5]);
        mynewpolys[6+(mysegments)*8]=addpolygon(mypolys[6]);
        mynewpolys[7+(mysegments)*8]=addpolygon(mypolys[7]);
        mynewpolys[8+(mysegments)*8]=addpolygon(mypolys[8]);

    editend();

    myaddpolys=mynewpolys;
//===============================================================================================================
//===============================================================================================================

// THIS DOES THE SELECTION!!!

//debug();
    selmode(USER);
    selpolygon(CLEAR);                          //Clears any user selection


//    if(mysub==1)
//    {

// REMMING OUT THE SELPOLYGON COMMAND MAKES IT WORK< BUT SUBPATCHES EVERYTHING.

// ATTEMPT 1:
// Selecting all the polys by ids from mynewpolys:

//        selpolygon(SET,POLYID,mynewpolys);
//        selpolygon(SET,POLYID,myaddpolys);
//        togglepatches();
//    }
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    mydone=1;
}








